<?php

namespace Drupal\simple_icons\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemInterface;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'simple_icons_icon' formatter.
 *
 * @FieldFormatter(
 *   id = "simple_icons_icon",
 *   label = @Translation("Simple Icons icon"),
 *   field_types = {
 *     "simple_icons_icon"
 *   }
 * )
 */
class SimpleIconsIcon extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = $this->viewValue($item);
    }

    return $elements;
  }

  /**
   * Generate the output appropriate for one field item.
   *
   * @param \Drupal\Core\Field\FieldItemInterface $item
   *   One field item.
   *
   * @return string
   *   The textual output generated.
   */
  protected function viewValue(FieldItemInterface $item) {
    $service = \Drupal::service('simple_icons.icon_markup');
    return $service->getIconMarkup($item->value);
  }

}
