<?php

namespace Drupal\simple_icons\TwigExtension;

/**
 * Class SimpleIconsTwigExtension.
 */
class SimpleIconsTwigExtension extends \Twig_Extension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'simple_icons.twig.extension';
  }

  /**
   * {@inheritdoc}
   *
   * @return array
   *   An array of Twig functions.
   */
  public function getFunctions() {
    return [
      new \Twig_SimpleFunction('simple_icons_icon', [$this, 'simpleIconsIcon']),
      ];
  }

  /**
   * Returns markup for a Simple Icons icon.
   *
   * @param string $slug
   *   The Simple Icon slug of the icon you want to print.
   *
   * @return string
   *   Markup of the SVG
   */
  public function simpleIconsIcon($slug) {
    $service = \Drupal::service('simple_icons.icon_markup');
    return $service->getIconMarkup($slug);
  }

}
